#!/usr/bin/perl
#
#######################################################
#		Top Referers version 2.0
#
#     		Created by: Solution Scripts 
# 		Email: solutions@solutionscripts.com
#		Web: http://solutionscripts.com
#
#######################################################
#
#
# COPYRIGHT NOTICE:
#
# Copyright 1998 Solution Scripts  All Rights Reserved.
#
# This program is being distributed as freeware.  It may be used and
# modified free of charge, so long as this copyright notice, the header 
# above and all the footers in the program that give me credit remain 
# intact. Please also send me an email, and let me know 
# where you are using this script. 
#
# By using this program you agree to indemnify Solution Scripts from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
######################################################

#### REMOVES REFERERS NOT ACTIVE AFTER THIS MANY DAYS ####
## SET HIGH IF YOU DON"T WANT IT TO AFFECT YOUR REFERERS ###
my $total_day  = 10;

####################
# OPTIONAL OPTIONS #
####################

# ALTERNATING TABLE COLORS
my @colors = ('silver','Gainsboro');

# FONT SIZE
my $font_size= "2";

# FONT FACE
my $font_face="verdana";

## EDIT NO MORE ##


use Fcntl;
use AnyDBM_File;
use Config;
use strict;
use vars qw(%INPUT);

my $current_time = time();
my $time = time;
(my $sec,my $min,my $hour,my $mday,my $mon,my $year,my $wday,my $yday,my $isdst) = localtime($time);
if ($year == 100) {
	$year = '00';
}
elsif ($year > 100) {
	$year = $year - 100;
}
$mon++;
my $now = "$mon.$mday.$year";
my $good_ref = '';


print "Content-type: text/html\n\n";
if ($ENV{'QUERY_STRING'}) {
	&keywords;
	exit;
}

my %INPUT;
read(STDIN, my $buffer, $ENV{'CONTENT_LENGTH'});
my @pairs = split(/&/, $buffer);
foreach my $pair (@pairs) {
	(my $name, my $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	if ($INPUT{$name}) { $INPUT{$name} = $INPUT{$name}.",".$value; }
	else { $INPUT{$name} = $value; }
}
my $cgiurl = $ENV{'SCRIPT_NAME'};

unless ($INPUT{'from'}) { $INPUT{'from'} =1; }
unless ($INPUT{'to'}) { $INPUT{'to'} =100; }
if ($INPUT{'to'} eq "all") { $INPUT{'to'} =1000000; }
if ($INPUT{'today'}) {
	$INPUT{'from'} =1;
	$INPUT{'to'} =1000000;
}


my @filters = split(/\,/,$INPUT{'filter'});

print qq~
<HTML><HEAD><TITLE>Top Referers</TITLE><HEAD>
<BODY vlink = SlateBlue link=black alink=#FF0000>
<h2 align=center>Top Referers</H2><BR>
<form action="$cgiurl" method="POST"><font size=-1 face=arial>
Show from &nbsp;<input type="Text" name="from" value="$INPUT{'from'}" size="4"> &nbsp;to&nbsp;<input type="Text" name="to" value="$INPUT{'to'}" size="4">
&nbsp;&nbsp;&nbsp;<input type="Submit" name="submit" value = "Submit"><BR><BR>
Show urls that first refered a hit on <input type="Text" name="today_date" value="$now" size="8">
&nbsp;&nbsp;&nbsp;<input type="Submit" name="today" value = "Submit">
</FONT></form>
~;

my $flags = O_CREAT | O_RDWR;
my $db = "referrer";
tie(my %acc, 'AnyDBM_File', $db , $flags, 0666) || &error("Cannot open database-- referer");

my $days=0;
my $months=0;
my $nums = 0;
my $total_count=0;
my $new_count =0;
my @sort ='';
foreach my $key (keys %acc) {
    my $value = $acc{$key};
	my @reffer_array = split(/\|/,$value);

	if ($now eq $reffer_array[5]){
		$days += $reffer_array[6] 
	}
	if ($mon eq $reffer_array[7]){
		$months += $reffer_array[8] 
	}
	
	$total_count = $total_count + $reffer_array[0];
	my $new_count = $new_count + $reffer_array[2];
	$sort[$nums] = "$reffer_array[0]||$key";
	$nums++;
	}

print qq~
<BR><FONT SIZE="$font_size" FACE="$font_face"><a href="$ENV{'SCRIPT_NAME'}?keywords">Click to see keywords used</A>
<BR>
<BR><FONT SIZE="$font_size" FACE="$font_face" color=red><B>$total_count</B></font> Total refferers counted</font>
<FONT SIZE="$font_size" FACE="$font_face"><I>(NOTE: This is not an acurate "hit" count)</I></font>
<BR><FONT SIZE="$font_size" FACE="$font_face" >From <FONT SIZE="$font_size" FACE="$font_face" color=red><B>$nums</B></font> different pages</font>
<BR><FONT SIZE="$font_size" FACE="$font_face" ><FONT SIZE="$font_size" FACE="$font_face" color=red><B>$days</B></font> refered today</font>
<BR><FONT SIZE="$font_size" FACE="$font_face" ><FONT SIZE="$font_size" FACE="$font_face" color=red><B>$months</B></font> this month</font>
<BR><FONT SIZE="$font_size" FACE="$font_face">With <FONT SIZE="$font_size" FACE="$font_face" color=red><B>$new_count</B></font> since last checked</font>
<BR><br>
<TABLE border=0 cellpadding=2><tr bgcolor=CornflowerBlue>
<TD align=center><FONT SIZE="$font_size"><B>Rank</B></TD>
<TD align=center><FONT SIZE="$font_size"><B>Hits</B></TD>
<TD align=center><FONT SIZE="$font_size"><B>New</B></TD>
<TD align=center><FONT SIZE="$font_size"><B>Day</B></TD>
<TD align=center><FONT SIZE="$font_size"><B>Today</B></TD>
<TD align=center><FONT SIZE="$font_size"><B>Month</B></TD>
<TD align=center><FONT SIZE="$font_size"><B>Refferer URL</B></TD>
</TR>
~;

my @sorteddata = sort {$a <=> $b } @sort;
my @revsort = reverse(@sorteddata);

my $color = 0;
my $day;
my $dayy;
my $num=0;
my $nnum=0;
my $print_out = 0;
my $print_now = '';

foreach my $line (@revsort) {

	my @sorted_array = split(/\|\|/,$line);
	my $key = @sorted_array[1];
    my $value = $acc{$key};
	my @reffer_array = split(/\|/,$value);

	$num++;	

	if ($num == $INPUT{'from'}) { $print_out =1; }
	if ($INPUT{'today'}) {
		if ($reffer_array[4] eq $INPUT{'today_date'}) { $print_out =1; }
		else { $print_out =0; }		
	}
	my $ffil="";	
	foreach my $fil(@filters) {
		if ($key =~ /$fil/i) { $ffil="$fil"; } 
	}
	if ($ffil) { $print_now=0; }
	else { $print_now =1; }
	
	if ($print_out && $print_now) {
		print"<TR bgcolor=$colors[$color]><TD align=center width=10><FONT SIZE=\"$font_size\" face=$font_face>$num</TD><TD align=center><FONT SIZE=\"$font_size\" face=$font_face>$reffer_array[0]</TD><td align=center><FONT SIZE=\"$font_size\" face=$font_face>";
	}
	if ($reffer_array[2]){
		if ($print_out && $print_now) { print"$reffer_array[2]"; }
		$reffer_array[2] = 0;
		$nnum = $num-1; 
		$acc{$key} = join("\|",@reffer_array);
		}
		else { if ($print_out && $print_now) { print" - "; } }
		if ($print_out && $print_now) { print "</TD><td align=center width=10><FONT SIZE=\"$font_size\" face=$font_face>"; }
		if ($reffer_array[3]){
			$dayy = $current_time - $reffer_array[3];
			$day = $dayy / 86400;
			$day = int($day);
			if ($print_out && $print_now) {
				if ($day) { print "$day"; }
				else { print"-"; }
			}
		}
		else { if ($print_out && $print_now) { print "N.A."; } }
		if ($day > $total_day) { delete ($acc{$key}); }
		if ($print_out && $print_now) { print "</TD><td align=center width=10><FONT SIZE=\"$font_size\" face=$font_face>"; }
		if ($reffer_array[5] eq $now){ if ($print_out && $print_now) { print "$reffer_array[6]"; } }
		else { if ($print_out && $print_now) { print "0"; } }
		if ($print_out && $print_now) { print "</TD><td align=center width=10><FONT SIZE=\"$font_size\" face=$font_face>"; }
		if ($reffer_array[7] eq $mon){ if ($print_out && $print_now) { print "$reffer_array[8]"; } }
		else { if ($print_out && $print_now) { print "0"; } }
		if ($print_out && $print_now) {
			print"</TD><TD width=100\%><FONT SIZE=\"$font_size\" face=$font_face><a href=\"$key\" TARGET=\"_blank\">$key</a></TD></TR>\n";
			if ($color) { $color=0; }
			else { $color++; }
		}
		if ($num == $INPUT{'to'}) { $print_out =0; }
}
untie (%acc);
print "</TABLE><center><br>\n";
print "<hr width=525 noshade size=1><A HREF=\"http://solutionscripts.com\">Top Referers </a>v2.0<br>Free from <A HREF=\"http://solutionscripts.com\">Solution Scripts</A><BR><BR>";
exit;


########## DISPLAY KEYWORDS ##########
sub keywords {

print qq~
<HTML><HEAD><TITLE>Top Keywords</TITLE><HEAD>
<BODY vlink = #003D84 link=black alink=#FF0000>
<center><FONT FACE="$font_face">Keywords used in popular search engines<BR><BR></font>
~;

my @engines = ('yahoo','infoseek','excite','hotbot','netfind','altavista','lycos','webcrawler','metacrawler','metafind','goto','dogpile');

foreach my $line(@engines) {
print <<EOF;
<table cellspacing=0 border=1 cellpadding =5 width=350>
<TR bgcolor=DARKSLATEBLUE><TD>
<FONT SIZE="-1" FACE="Arial" color=white><B>$line
</B></FONT>
</TD></TR>
EOF

my $flags = O_CREAT | O_RDWR;
my $db = "$line";
tie(my %eng, 'AnyDBM_File', $db , $flags, 0666) || &error("Cannot open database-- referrer");


$num = 0;


#foreach $lines(@sort) {

foreach my $lines (sort_hashs(\%eng))  {
	my @searchs = split(/\|\|\|/,$eng{$lines});
	$num=1;
print <<EOF;

<TR bgcolor=#C0C0C0>
<TD>
<FONT SIZE="-2" FACE="Arial">$searchs[0] -
EOF
if ($searchs[1]) {
print qq~<A HREF = \"$searchs[1]\" target="_blank">$lines</A>~;
}
else { print "$lines"; }

print "</font></td></TR>";

}
unless ($num) {
print <<EOF;
<TR bgcolor=#C0C0C0>
<TD>
<FONT SIZE="-2" FACE="Arial">NONE</TD></TR>
EOF
}


untie %eng;
print "</TABLE><BR><BR>\n";
}

print "</TABLE><BR><BR></I><blockquote><small>Know of a popular search engine not listed, let us know and we will add it in the next release</SMALL></I></blockquote><BR><BR>";
print "<hr width=525 noshade size=1><A HREF=\"http://solutionscripts.com\">Top Referers </a>v2.0<br>Free from <A HREF=\"http://solutionscripts.com\">Solution Scripts</A><BR><BR>";

exit;

}

sub error {

print qq~
<HTML><BODY>
<TABLE border=0 align=center>
<TR><TD><FONT FACE=arial size=-1>
<B>Error</B> - $_[0] - $!
<BR><BR>
Any and all problems regarding the runniong and using of Top Referers<BR>
should be posted on our help forum at:<BR>
<A HREF="http://solutionscripts.com/forum"><B>http://solutionscripts.com/forum</B></A>
<BR><BR>
<A HREF="http://solutionscripts.com"><B>Solution Scripts</B></A><BR><BR>
~;

exit;
}


sub sort_hashs {
	my $x = shift;
	my %array = %$x;
	sort { $array{$b} <=> $array{$a}; } keys %array;

}